﻿using igDataChart.ModelInController.Models;
using Infragistics.Web.Mvc;
using System.Linq;
using System.Web.Mvc;

namespace igDataChart.ModelInController.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View(createChartModel());
        }

        private DataChartModel createChartModel()
        {
            var model = new DataChartModel();

            model.Width = "400px";
            model.Height = "300px";
            model.DataSource = new Records().AsQueryable();

            model.Legend = new LegendModel { ID = "chartLegend" };

            model.Axes.Add(new CategoryXAxisModel { Name = "xAxis", Title = "Years", Label = "Year" });
            model.Axes.Add(new NumericYAxisModel { Name = "yAxis", Title = "Millions of People", MinimumValue = 0 });

            model.Series.Add(createSeries("CN", "China"));
            model.Series.Add(createSeries("IN", "India"));
            model.Series.Add(createSeries("US", "United States"));

            return model;
        }

        private SeriesModel createSeries(string seriesMemberPath, string seriesName)
        {
            var series = new LineSeriesModel();

            series.XAxis = "xAxis";
            series.YAxis = "yAxis";
            series.ValueMemberPath = seriesMemberPath;
            series.Name = seriesName;
            series.Title = seriesName;
            series.Thickness = 3;

            return series;
        }
    }
}